:- module(alle_Module).			% Der Name des Modules wird definiert.

:- lib(ic).			

:- export alle_basis_Module / 1.
:- export alle_Vertiefungsmodule / 1.
:- export alle_Anwendungsfachmodule /1.
:- export alle_Ergaenzungsmodule / 1.
:- export das_Abschlussmodul / 1.

					%


:- export struct(b_modul(modul_nr, vtg, lehrform,cp, rhytmus)).
:- export struct(v_modul(modul_nr, gebiet, lehrform, cp, rhytmus, vorauss)).
:- export struct(a_modul(modul_nr, cp, rhytmus)).
:- export struct(erg_modul(modul_nr, cp, lehrform, rhytmus, vorauss)).
:- export struct(afm_modul(modul_nr, cp, durchschnittsnote)).


					%

/*

			Strukturen_Uebesicht

	1.0 alle_basis_Module /1.
	2.0 alle_Vertiefungsmodule / 1.
	3.0 alle_Anwendungsfachmodule /1.
	4.0 alle_Ergaenzungsmodule / 1.
	5.0 das_Abschlussmodul / 1.

*/

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 1.0

/*  Hier wird dem System alle wichtige Informationen ueber Basismodulen mitgeteilt. 
Die Struktur alle_basis_Module enthaelt alle Module des Vertiefungsgebietes. */



alle_basis_Module([
	
	b_modul{modul_nr:b_PRG, vtg: prog1, lehrform:vlg, cp:17, rhytmus: ws},
	b_modul{modul_nr:b_PRG, vtg: prog2, lehrform:vlg, cp:17, rhytmus: ss},

	b_modul{modul_nr:b_HW, vtg: edgi, lehrform:vlg, cp:14, rhytmus: ws},
	b_modul{modul_nr:b_HW, vtg: hwr, lehrform:vlg, cp:14, rhytmus: ss},

	b_modul{modul_nr:b_MOD, vtg:mod, lehrform:vlg, cp:7, rhytmus:ws},

	b_modul{modul_nr:b_DS, vtg: ds, lehrform:vlg, cp:5, rhytmus:ss},  % 

	b_modul{modul_nr:b_GL, vtg: gl1, lehrform:vlg, cp:16, rhytmus:ws},
	b_modul{modul_nr:b_GL, vtg: gl2, lehrform:vlg, cp:16, rhytmus:ss},

	b_modul{modul_nr:b_PRG_pr, vtg: prog_pr, lehrform:prakt, cp:8, rhytmus:ws},  

	b_modul{modul_nr:b_HWS_pr, vtg: hws_pr, lehrform:prakt, cp:4, rhytmus:ss},  
	
	b_modul{modul_nr:b_M1, vtg: m1, lehrform:vlg, cp:9,rhytmus:ws},	
		 		
	b_modul{modul_nr:b_M2, vtg: m2_a, lehrform:vlg, cp:18, rhytmus:ws},
	b_modul{modul_nr:b_M2, vtg: m2_b, lehrform:vlg, cp:18, rhytmus:ss},
	b_modul{modul_nr:b_M2, vtg: m2_c, lehrform:vlg, cp:18, rhytmus:ss} ]).
	



	
		

%---------------------------------Ende basismodule-----------------------

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2.0

/*  Hier wird dem System alle wichtige Informationen ueber Vertiefungsmodulen mitgeteilt. 
Die Struktur alle_Vertiefungsmodule enthaelt alle Module des Vertiefungsgebietes. */




alle_Vertiefungsmodule([

	v_modul{modul_nr:b_VS, gebiet:bkspp, lehrform:vlg, cp:6, rhytmus:zj, vorauss:1}, 
        	v_modul{modul_nr:b_VS_PR, gebiet:bkspp, lehrform:prkt, cp:8, rhytmus:zj, vorauss:1},
	v_modul{modul_nr:b_BS, gebiet:bkspp, lehrform:vlg, cp:9, rhytmus:zj, vorauss:1},
	v_modul{modul_nr:b_ST, gebiet:bkspp, lehrform:vlg, cp:6, rhytmus:zj, vorauss:1},  
	v_modul{modul_nr:b_EPF, gebiet:bkspp, lehrform:vlg, cp:5, rhytmus:ws, vorauss:1}, 
       	v_modul{modul_nr:b_PR_BS, gebiet:bkspp, lehrform:smn, cp:4, rhytmus:zj, vorauss:1}, 
	v_modul{modul_nr:b_KS_BS, gebiet:bkspp, lehrform:smn, cp:4, rhytmus:zj, vorauss:1},


%%  Ende Vertiefungsgebiet (bkspp) Betriebs- und Kommunikationssysteme 	
%%  und Programmiersprachen und -Paradigmen


%---------------------------------------------------------------------------	
	

	v_modul{modul_nr:b_DB1, gebiet:iswv, lehrform:vlg, cp:9, rhytmus:zj, vorauss:1}, 
        	v_modul{modul_nr:b_DB2, gebiet:iswv, lehrform:vlg, cp:6, rhytmus:zj, vorauss:1}, 
	v_modul{modul_nr:b_IS_BS, gebiet:iswv, lehrform:smn, cp:4, rhytmus:zj, vorauss:1}, 
	v_modul{modul_nr:b_KI, gebiet:iswv, lehrform:vlg, cp:6, rhytmus:zj, vorauss:1}, 
	v_modul{modul_nr:b_WV_BS, gebiet:iswv, lehrform:smn, cp:4, rhytmus:zj, vorauss:1},
	v_modul{modul_nr:b_CLT, gebiet:iswv, lehrform:vlg, cp:9, rhytmus:zj, vorauss:2}, 
				
	v_modul{modul_nr:b_AS, gebiet:iswv, lehrform:vlg, cp:9, rhytmus:zj, vorauss:3},  

	v_modul{modul_nr:b_AS_PR, gebiet:iswv, lehrform:prkt, cp:8, rhytmus:zj, vorauss:3},

	v_modul{modul_nr:b_AS_BS, gebiet:iswv, lehrform:smn, cp:4, rhytmus:zj, vorauss:1}, 


%%  Ende Vertiefungsgebiet (iswv) Informationssysteme und Wissensverarbeitung


%%-------------------------------------------------------------------------

 
	v_modul{modul_nr:b_RA, gebiet:ts, lehrform:vlg, cp:6, rhytmus:ws, vorauss:1},
       	v_modul{modul_nr:b_RT, gebiet:ts, lehrform:vlg, cp:6, rhytmus:ws, vorauss:1},
	v_modul{modul_nr:b_ES, gebiet:ts, lehrform:vlg, cp:6, rhytmus:zj, vorauss:4}, 
	v_modul{modul_nr:b_AIS, gebiet:ts, lehrform:vlg, cp:6, rhytmus:zj, vorauss:1},
	v_modul{modul_nr:b_REM, gebiet:ts, lehrform:vlg, cp:6, rhytmus:ss, vorauss:1}, 
	v_modul{modul_nr:b_EM_BS, gebiet:ts, lehrform:smn, cp:4, rhytmus:zj, vorauss:1}, 
	v_modul{modul_nr:b_SYSA_BS, gebiet:ts, lehrform:smn, cp:4, rhytmus:zj, vorauss:1}, 
	v_modul{modul_nr:b_ASI_PR, gebiet:ts, lehrform:prkt, cp:8, rhytmus:zj, vorauss:1},

	

%%  Ende Vertiefungsgebiet (ts) Technische Systeme
%%---------------------------------------------------------------------------


	v_modul{modul_nr:b_SIM, gebiet:ani, lehrform:vlg, cp:6, rhytmus:zj, vorauss:3}, 

	v_modul{modul_nr:b_SIM_PR, gebiet:ani, lehrform:prkt, cp:8, rhytmus:zj, vorauss:1}, 
	v_modul{modul_nr:b_CG, gebiet:ani, lehrform:vlg, cp:6, rhytmus:ss, vorauss:1}, 
	v_modul{modul_nr:b_HCI, gebiet:ani, lehrform:vlg, cp:4, rhytmus:ws, vorauss:1},
	v_modul{modul_nr:b_OGL, gebiet:ani, lehrform:vlg, cp:6, rhytmus:zj, vorauss:1}, 
	v_modul{modul_nr:b_MMS, gebiet:ani, lehrform:vlg, cp:3, rhytmus:ss, vorauss:1}, 
	v_modul{modul_nr:b_STCG, gebiet:ani, lehrform:vlg, cp:3, rhytmus:zj, vorauss: 1},
	v_modul{modul_nr:b_VC_PR, gebiet:ani, lehrform:prkt, cp:8, rhytmus:ws, vorauss:5},
	v_modul{modul_nr:b_DBV, gebiet:ani, lehrform:vlg, cp:6, rhytmus:ss, vorauss:6},
	v_modul{modul_nr:b_ANI_BS, gebiet:ani, lehrform:smn, cp:4, rhytmus:zj, vorauss:1}, 
	

%%  Ende Vertiefungsgebiet Angewandte Informatik
%%---------------------------------------------------------------------------
	

	v_modul{modul_nr:b_EAL, gebiet:gdi, lehrform:vlg, cp:9, rhytmus:ss, vorauss:2},	
	v_modul{modul_nr:b_KRY, gebiet:gdi, lehrform:vlg, cp:9, rhytmus:zj, vorauss:1}, 
	v_modul{modul_nr:b_MFS_bs, gebiet:gdi, lehrform:smn, cp:4, rhytmus:zj, vorauss:7},
	v_modul{modul_nr:b_BK1, gebiet:gdi, lehrform:vlg, cp:9, rhytmus:zj, vorauss:7},
	v_modul{modul_nr:b_KUK_BS, gebiet:gdi, lehrform:smn, cp:4, rhytmus:js, vorauss:1},
	v_modul{modul_nr:b_EAL_BS, gebiet:gdi, lehrform:smn, cp:4, rhytmus:zj, vorauss:1}  
		]).

%%  Ende Vertiefungsgebiet Grundlage der Informatik
%%---------------------------------------------------------------------------



%---------------------------------Ende VertiefungsModule--------------




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3.0

/*  Hier wird dem System alle wichtige Informationen ueber die Module zum gewhlten 
Anwendungsfach  mitgeteilt. 
Die Struktur alle_Anwendungsfachmodule enthaelt alle Module des Vertiefungsgebietes. */


alle_Anwendungsfachmodule([
		afm_modul{modul_nr:x, cp:24, durchschnittsnote: 3.7}
		            ]).



%---------------------------------Ende Anwendungsfachmodule------------




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 4.0


/*  Hier wird dem System alle wichtige Informationen ueber Ergaenzungsmodule mitgeteilt. 
Die Struktur alle_Ergaenzungsmodule enthaelt alle Module des Vertiefungsgebietes. */


alle_Ergaenzungsmodule([

	erg_modul{modul_nr:b_TL, cp:3, lehrform: tut_ltg, rhytmus: js, vorauss:1}, 

	erg_modul{modul_nr:b_NMG, cp:3, lehrform:vlg, rhytmus: ws, vorauss:1}, 

	erg_modul{modul_nr:b_PM, cp:3, lehrform:vlg, rhytmus: ws, vorauss:1} 
		
		]).   


%---------------------------------Ende Ergaenzungsmodule----------------



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 5.0

/*  Hier wird dem System alle wichtige Informationen ueber das Abschlussmodul mitgeteilt. 
Die Struktur das_Abschlussmodul enthaelt alle Module des Vertiefungsgebietes. */


das_Abschlussmodul([
	a_modul{modul_nr:b_BA_os, cp:3, rhytmus:js},   
	a_modul{modul_nr:b_BA_ba, cp:12, rhytmus:js}   

		
		]).


%---------------------------------Ende Abschlussmodul----------------





