:- module(simulation_Bachelor). 		
					% Der Name des Modules wird definiert.

:- use_module(student).
:- use_module(alle_Module).
:- use_module(basismodule).
:- use_module(vertiefungsmodule).
:- use_module(ergaenzungsmodule).
:- use_module(abschlussmodul).
:- use_module(anwendungsfachmodule).				
					% Hier werden alle Module geladen.

:- lib(ic).	   			% Die ic-Bibliothek wird geladen.





/*
			Praedikaten-Uebersicht

			Bachelormodul


		10.1	bachelor_abgeschlossen(Gesamt_Durchschnitt, Gesamt_CP).
		10.1  	abrunden / 2,
		10.2  	erzielte_CP_insgesamt_mindestens_180 / 2.
*/


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  Klausel 10.		
	

bachelor_abgeschlossen(Gesamt_Durchschnitt, Gesamt_CP) :-
	berechne_Durchschnittsnote_Basismodule(Durchschnitt_1, CP_Basis, CP_1 ),
			% Hier wird Durchschnittsnote und Gesamt-CP
			% fuer Basismodule berechnet.


	finde_best_moegliche_durchschnittsnote_Vertiefung(Durchschnitt_2, _),
	berechne_Durchschnittsnote_Vertiefung(CP_2, _, CP_Vertiefung,  _, _),
			% Hier wird Durchschnittsnote und Gesamt-CP
			% fuer Vertiefungsmodule berechnet.


	anwendungsfachmodule_abgeschlossen(Durchschnitt_3, CP_3),
			% Hier wird Durchschnittsnote und Gesamt-CP
			% fuer Abschlussmodul berechnet.

	bachelorarbeit_erfolgreich_abgesch(Durchschnitt_4, CP_4),

			% Hier wird Durchschnittsnote und Gesamt-CP
			% fuer Abschlussmodul berechnet.

	erzielte_CP_Ergaenzung(CP_Ergaenzung),

	erzielte_CP_insgesamt_mindestens_180([CP_Basis, CP_Vertiefung, CP_3, CP_4, CP_Ergaenzung], Gesamt_CP),

	L1 = [Durchschnitt_1, Durchschnitt_2, Durchschnitt_3, Durchschnitt_4],
	L2 = [CP_1, CP_2, CP_3, CP_4],

	(foreach(X, L1),
	foreach(Y, L2),
	foreach(Z, L3) do
		*(X, Y, Z)
	),
	sum(L3, Gewichtung),
	sum(L2, CP_Gesamt),
	/(Gewichtung, CP_Gesamt, X),
	abrunden(X, Gesamt_Durchschnitt),
	print(L3), nl,
	print(L1), nl,
	print(L2), nl.
	

	

			% Hier wird CP-gewichteter Gesamt-Durchschnitt fuer das Bachelor berechnet, indem alle durchschnittnoten
			% im Basis-, Vertiefung-, Anwendungs- und Bachelorarbeitmodue betrachtet werden.
			
	
%
%%%%%%%%%%%%%%%%   Ende des Prdikats %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



	/* Im folgenden werden Praedikate definiert, die in  Klausel 4. benutzt wurden.*/



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% 10.1

erzielte_CP_insgesamt_mindestens_180(Liste, Gesamt_CP) :-
	sum(Liste, Gesamt_CP),
	Gesamt_CP #>= 180.

		% Hier wird die gesamten erreichten Cp in allen Modulen berechnet.			


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% 10.2 

abrunden(X, Z) :-
	*(X, 10, Y),  
	fix(Y, T), 
	/(T, 10, Z).      
			% Mit Hilfe eingebauter Praedikate wird beim abrunden nur die
			% erste Dezimalstelle nach dem Komma beruecksichtigt


	

