:- module(student).				% Der Name des Modules wird definiert.

:- export absolvierte_studienleistungen /1.	
:- export pruefungsversuche_BM  /1.
:- export pruefungsversuche_VM  /1.
:- export drei_Wahlgebiete_Vertiefung /1.
:- export erfolgreiche_pruefungsversuche_EM /1.		
:- export pruefungsversuch_OS /1.
:- export pruefungsversuch_BA /1.
					% 


:- export struct(studienleistung(vtg,  pruefungszeit, semester)).		
:- export struct(pruefung_basis(modul_nr, pruefungszeit, note)).
:- export struct(pruefung_vertiefung(modul_nr, pruefungszeit, note)).
:- export struct(wahlgebiet(gebiet_1, gebiet_2, gebiet_3)).
:- export struct(ergaenzungsmodul(modul_nr, pruefungszeit)).	
:- export struct(oberseminar(modul_nr, note, pruefungszeit)).
:- export struct(bachelorarbeit(modul_nr, noten, pruefungszeit)).
  
					%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


absolvierte_studienleistungen([		
		studienleistung{vtg: prog1, pruefungszeit:7, semester: ws},
		studienleistung{vtg: prog2, pruefungszeit:4, semester: ss},								studienleistung{vtg: edgi, pruefungszeit:6, semester: ws},
		studienleistung{vtg:hwr, pruefungszeit:2, semester: ss},
		studienleistung{vtg: gl2, pruefungszeit:6, semester: ss},
		studienleistung{vtg: gl1, pruefungszeit:2, semester: ws}
	  	              ]).

		% Hier werden alle absolvierte Studienleistungen im Basismodul geschrieben. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

pruefungsversuche_BM([
		
	      	pruefung_basis{modul_nr:b_HW, pruefungszeit:4, note:1.0},
		%pruefung_basis{modul_nr:b_PRG, pruefungszeit:5, note:5.0}, 
	      	%pruefung_basis{modul_nr:b_PRG, pruefungszeit:6, note:5.0}, 
		%pruefung_basis{modul_nr:b_PRG, pruefungszeit:7, note:5.0}, 
		pruefung_basis{modul_nr:b_PRG, pruefungszeit:6, note:2.0},
	     	pruefung_basis{modul_nr:b_MOD, pruefungszeit:1, note:3.0},
	     	pruefung_basis{modul_nr:b_DS, pruefungszeit:1, note:1.0},
	     	pruefung_basis{modul_nr:b_GL, pruefungszeit:3, note:1.0},
	     	pruefung_basis{modul_nr:b_PRG_pr, pruefungszeit:6, note:b},
	     	pruefung_basis{modul_nr:b_HWS_pr, pruefungszeit:4, note:b},
	     	pruefung_basis{modul_nr:b_M1,  pruefungszeit:2, note:1.0},
		pruefung_basis{modul_nr:b_M2, pruefungszeit:5, note:1.0}	
           	              ]).


		% Hier werden alle Pruefungsversuche im Basismodul geschrieben. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

pruefungsversuche_VM([		
	

	

	pruefung_vertiefung{modul_nr:b_ASI_PR,  pruefungszeit:5, note:b},
	pruefung_vertiefung{modul_nr:b_AS,  pruefungszeit:6, note:2.0}, 
	pruefung_vertiefung{modul_nr:b_VC_PR,  pruefungszeit:6, note:b},	
	pruefung_vertiefung{modul_nr:b_BS, pruefungszeit:5, note:1.7}, 
	pruefung_vertiefung{modul_nr:b_PR_BS,  pruefungszeit:5, note:1.7},
	pruefung_vertiefung{modul_nr:b_SIM_PR,  pruefungszeit:5, note:b}, 
	pruefung_vertiefung{modul_nr:b_EAL_BS,  pruefungszeit:1, note:1.7},
	pruefung_vertiefung{modul_nr:b_BK1, pruefungszeit:5, note:1.7}, 
	pruefung_vertiefung{modul_nr:b_VS_PR, pruefungszeit:7, note:b} 

	
	%pruefung_vertiefung{modul_nr:b_DBV,  pruefungszeit:7, note:1.7},
	%pruefung_vertiefung{modul_nr:b_OGL, pruefungszeit:6, note:1.7}, 			
	%pruefung_vertiefung{modul_nr:b_KUK_BS,  pruefungszeit:1,  note:2.7} ,
	%pruefung_vertiefung{modul_nr:b_OGL,  pruefungszeit:6, note:b}
	  

        		      ]).



		% Hier werden alle Pruefungsversuche im Vertiefungsmodul geschrieben. 



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

drei_Wahlgebiete_Vertiefung([wahlgebiet{gebiet_1:bkspp, gebiet_2:ani, gebiet_3:gdi}]).

%drei_Wahlgebiete_Vertiefung([wahlgebiet{gebiet_1:bkspp, gebiet_2:ani, gebiet_3:gdi}]).

		% Hier Schreibt der Student seine drei Wahlgebiete, in der er verpflichtet ist 
		% 16, 8, bzw. nochmal 8 CP zu erzielen.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

erfolgreiche_pruefungsversuche_EM([
	
	ergaenzungsmodul{modul_nr: [b_TL, b_BK1], pruefungszeit: 5}

	%ergaenzungsmodul{modul_nr:b_NMG, pruefungszeit: 5},
	%ergaenzungsmodul{modul_nr:b_PM, pruefungszeit: 5}
		]).

		
		% Hier werden alle erfolgreiche Pruefungsversuche im Ergaenzungsmodul geschrieben. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


pruefungsversuch_OS([
	oberseminar{modul_nr:b_BA_os, note:2.3, pruefungszeit:5}
	
		 ]).


		% Hier werden alle Versuche geschrieben, das Oberseminar im Abschlussmodul
		% zu machen . 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


pruefungsversuch_BA([
	bachelorarbeit{modul_nr:b_BA_ba, noten:[5.0, 2.0, 2.0], pruefungszeit:5}
	
	%bachelorarbeit{modul_nr:b_BA_ba, noten:[1.3, 3.0], pruefungszeit:6}
		]).

		% Hier werden alle Versuche geschrieben, die Bachelorarbeit im Abschlussmodul 
		% zu machen . 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	