:- module(vertiefungsmodule). 		% Der Name des Modules wird definiert.


:- export(pruefe_ob_alle_Vertiefungsmodule_regelgemaess_abgesch / 1).
:- export(suche_alle_bestandene_Module_Vertiefung / 1).
:- export(finde_CP_des_Moduls / 2).
:- export(ein_Wahlpflichtmodul_abgesch_Vertiefung / 1).
:- export(finde_best_moegliche_durchschnittsnote_Vertiefung / 2).
:- export(berechne_Durchschnittsnote_Vertiefung / 5).
				
					%
		
:- use_module(student).
:- use_module(alle_Module).
:- use_module(basismodule).
					% Hier Werden Module geladen, die 
					% in diesem Modul aufgerufen werden.



:- lib(ic).	   				% Die ic-Bibliothek wird geladen.


/*
			Prdikaten-bersicht

			VERTIEFUNGSMODULE


	4. ein_Wahlpflichtmodul_abgesch_Vertiefung(Modul).
		4.1  das_Modul_ist_ein_Vertiefungsmodul / 2,
		4.2  nicht_bereits_2_mal_Pruefung_wiederholt / 1,
		4.3  cp_Konto_nicht_ueberlastet / 1,
		4.4  modulabschlusspruefung_bestanden_Vertiefung / 2,
		4.5  zulassungsvoraussetzung_Vertiefung / 2,
		4.5.1  voraussetzung_HW_PRG_MOD_DS / 1,
		4.5.2  voraussetzung_MOD_DS / 1,
		4.5.3  voraussetzung_M1_M2 / 1,
	  	4.5.4  voraussetzung_PRG_HW / 1,
		4.5.5  voraussetzung_PRG_pr / 1,
		4.5.6  voraussetzung_PRG / 1,
		4.5.7  voraussetzung_MOD_DS_GL / 1,

				
	5. das_Gebiet_Vertiefungsmodul_abgesch(Module, CP_Summe, Gebiete).


	5.1  suche_alle_bestandene_Module_Vertiefung / 1,
		5.2  pruefe_ob_alle_Vertiefungsmodule_regelgemaess_abgesch / 1,
		5.3  die_CP_Summe_mindestens_40 / 2,
		5.4  seminar_und_Praktikum_enthalten / 2,
		5.5  drei_disjunkte_Gebiete / 3,
		
	

	6.  finde_best_moegliche_durchschnittsnote_Vertiefung(Durchschnitt, Variationen).


	7.  berechne_Durchschnittsnote_Vertiefung(CP_Gesamt, List_CP, CP_Vertiefung, 
		CP_Anteile, Durchschnittsnote)
		
		7.1  suche_alle_erzielte_CP / 2,
		7.2  suche_alle_erzielte_Noten /2,	
		7.3  ordne_CP_Anteile_zu / 2,
		7.4  gewichtung_der_Noten_durch_CP / 3,
		7.5  bilde_CP_Summe_der_benoteten_Module / 3,
		7.6  die_CP_der_Wunschgebiete_erfuellt / 4,
			7.6.1  suche_die_drei_Wunschgebiete / 3,
			7.6.2  finde_Gebiet_des_Moduls /2,
			7.6.3  summiere_CP_im_Gebiet / 4,
		7.  zwischenergebnisse / 8,

*/



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%          Prdikate bezglich  Vertiefungsmodule        %%%%%%%%%%
%
%  Prdikat 4.


ein_Wahlpflichtmodul_abgesch_Vertiefung(Modul) :-

	das_Modul_ist_ein_Vertiefungsmodul(Modul, Voraussetzung),
				% Modul ist ein Vertiefungsmodul.
	
	nicht_bereits_2_mal_Pruefung_wiederholt(Modul),
				% Der Student hat nicht bereits zweimal
				% die Modulabschlussprfung wiederholt.

	cp_Konto_nicht_ueberlastet(_Modul),
				% Hier wird geprftt, ob der Student noch freie Versuche hat.
	
	modulabschlusspruefung_bestanden_Vertiefung(Modul, Zeit),
				% Student hat das Modul mit Erfolg abgeschlossen.
	
	zulassungsvoraussetzung_Vertiefung(Voraussetzung, Zeit).
				% Zulassungsvoraussetzung erfllt.
	

%
%%%%%%%%%%%%%%%%   Ende des Prdikats    %%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


 	/* Im folgenden werden Klauseln definiert, die in  Prdikat 4. benutzt wurden.*/


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 4.1  
          
das_Modul_ist_ein_Vertiefungsmodul(M, V) :-
		alle_Vertiefungsmodule(Y),		
		member(v_modul{modul_nr:M, vorauss:V}, Y).
	  			% Hier wird geprft, ob M ein gltige 
				% Bezeichnung eines Vertiefungsmoduls ist und
				% wenn ja, wird der Variable V die fr das Modul
				% geltende Vorausetzung (vorauss) zugeordnet.
 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 4.2  

nicht_bereits_2_mal_Pruefung_wiederholt(M) :-
	pruefungsversuche_VM(W1),
	(foreach(Z1, W1), fromto(W2, Out, In, []), param(M)  do
     		Z1 = [M| _] -> Out = [Z1|In]
		; Out = In), 
 			 % Hier werden alle Prfungsversuche in dem selben Modul
			% rausgefiltert und in die Liste W2 geschrieben.

	(foreach(Z2, W2), fromto(W3, Out, In, []) do
     		arg(4, Z2, 5.0) -> Out = [Z2|In]; Out = In), 
		length(W3, D),
		D#<  3.
			
			% Hier werden alle fehlgeschlagene Prfungsversuche 
			% rausgefiltert und in die Liste W3 geschrieben, mit der 
			% Bedingung dass, W3 weniger als 3 Elemente enthalten darf.  

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 4.3  

cp_Konto_nicht_ueberlastet(C) :-
	pruefungsversuche_VM(W),
	
	(foreach(X, W),
	foreach(Y, T1) do
		finde_die_Modul_nr(X, Y)),
		
	(foreach(X, T1),
	foreach(Y, T2) do
		finde_CP_des_Moduls(X, Y)),	
	
	sum(T2, C),
	C #=< 100.	
				% Hier werden alle Prfungsversuche gesucht
				% um anschliessend zu prfen, ob verbrauchte
				% CP  nicht mehr als 100 betrgt.
		
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
%%%%%%%%%% 4.3.1

	
finde_die_Modul_nr(pruefung_vertiefung{modul_nr:M}, Z) :-
	M = Z.	
				% Mit dieser Klausel wird der Variable Z 
				% Modulnummer M zugeordnet.  

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% 4.3.2

finde_CP_des_Moduls(X, Y) :-
	alle_Vertiefungsmodule(W),
	member(v_modul{modul_nr:X, cp:Y}, W).



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 4.4  

modulabschlusspruefung_bestanden_Vertiefung(M, Z) :-
	pruefungsversuche_VM(W),
	member(pruefung_vertiefung{modul_nr:M,  pruefungszeit:Z, note:X}, W),
	not(X = 5.0), 		
	not(X = nb).		
				% Hier wird geprft, ob Student zum Zeitpunkt Z
				% das Modul M mit Erfolg abgeschlossen hat.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 4.5
 

zulassungsvoraussetzung_Vertiefung(Voraussetzung, Zeit) :-
	(Voraussetzung = 1  -> voraussetzung_HW_PRG_MOD_DS(Zeit)
	;
	 true),
	(Voraussetzung = 2  ->  voraussetzung_MOD_DS(Zeit)
	; 
	true),
	(Voraussetzung = 3  -> voraussetzung_M1_M2(Zeit)
	; true),
	(Voraussetzung = 4  -> voraussetzung_PRG_HW(Zeit)
	; true),
	(Voraussetzung = 5  ->  voraussetzung_PRG_pr(Zeit)
	; true),
	(Voraussetzung = 6  -> voraussetzung_PRG(Zeit)
	; true),
	(Voraussetzung = 7  -> voraussetzung_MOD_DS_GL(Zeit)
	; true).
			% Hier wird je nach Voraussetzung Klauseln aufgerufen.
		

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 4.5.1


voraussetzung_HW_PRG_MOD_DS(Zeit) :- 
	pruefungsversuche_BM(W),
	member(pruefung_basis{modul_nr:b_HW, pruefungszeit:Zeitpunkt, note:X},W),
	not(X = 5.0),
	Zeitpunkt #=< Zeit, !.  		
			% Hier wird geprft, ob das Modul b_HW abgeschlossen ist.

voraussetzung_HW_PRG_MOD_DS(Zeit) :- 
	pruefungsversuche_BM(W),
	member(pruefung_basis{modul_nr:b_PRG, pruefungszeit:Zeitpunkt, note:X},W),
	not(X = 5.0),
	Zeitpunkt #=< Zeit, !.		
			% Hier wird geprft, ob das Modul b_PRG abgeschlossen ist.

voraussetzung_HW_PRG_MOD_DS(Zeit) :-
	pruefungsversuche_BM(W),
	member(pruefung_basis{modul_nr:b_MOD, pruefungszeit:Zeitpunkt1, note:X1},W), 	
	member(pruefung_basis{modul_nr:b_DS, pruefungszeit:Zeitpunkt2, note:X2},W),
	not(X1 = 5.0),
	not(X2 = 5.0),
	Zeitpunkt1 #=< Zeit,		
	Zeitpunkt2 #=< Zeit.		
			% Hier wird geprft, ob beide Module (b_MOD und b_DS)
			% bereits abgeschlossen sind.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 4.5.2

 voraussetzung_MOD_DS(Zeit) :-
	pruefungsversuche_BM(W),
	member(pruefung_basis{modul_nr:b_MOD, pruefungszeit:Zeitpunkt1, note:X1},W), 	
	member(pruefung_basis{modul_nr:b_DS, pruefungszeit:Zeitpunkt2, note:X2},W),
	not(X1 = 5.0),
	not(X2 = 5.0),
	Zeitpunkt1 #=< Zeit,		
	Zeitpunkt2 #=< Zeit.		
			% Hier wird geprft, ob beide Module (b_MOD und b_DS)
			% bereits abgeschlossen sind.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 4.5.3

voraussetzung_M1_M2(Zeit) :-
	voraussetzung_HW_PRG_MOD_DS(Zeit),	
	
	pruefungsversuche_BM(W),
	member(pruefung_basis{modul_nr:b_M1, pruefungszeit:Zeitpunkt1, note:X1},W), 	
	member(pruefung_basis{modul_nr:b_M2, pruefungszeit:Zeitpunkt2, note:X2},W),
	not(X1 = 5.0),
	not(X2 = 5.0),
	Zeitpunkt1 #=< Zeit,		
	Zeitpunkt2 #=< Zeit.		
			% Hier wird geprft, ob beide Module (b_M1 und b_M2)
			% bereits abgeschlossen sind sowie die oben definierte  
			%  Bedingung (voraussetzung_HW_PRG_MOD_DS) erfllt 
			% ist.  

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 4.5.4

 voraussetzung_PRG_HW(Zeit) :-
	pruefungsversuche_BM(W),
	member(pruefung_basis{modul_nr:b_PRG, pruefungszeit:Zeitpunkt1, note:X1},W), 	
	member(pruefung_basis{modul_nr:b_HW, pruefungszeit:Zeitpunkt2, note:X2},W),
	not(X1 = 5.0),
	not(X2 = 5.0),
	Zeitpunkt1 #=< Zeit,		
	Zeitpunkt2 #=< Zeit.		
			% Hier wird geprft, ob beide Module (b_PRG und b_HW)
			% bereits abgeschlossen sind.	


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 4.5.5


 voraussetzung_PRG_pr(Zeit) :-
	voraussetzung_HW_PRG_MOD_DS(Zeit),
	pruefungsversuche_BM(W),
	member(pruefung_basis{modul_nr:b_PRG_pr, pruefungszeit:Zeitpunkt, note:X},W),
	not(X = 5.0),
	Zeitpunkt #=<Zeit.		
		% Hier wird geprft, ob das Modul b_PRG_pr abgeschlossen ist.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 4.5.6


voraussetzung_PRG(Zeit) :-
	pruefungsversuche_BM(W),
	member(pruefung_basis{modul_nr:b_PRG, pruefungszeit:Zeitpunkt, note:X},W),
	not(X = 5.0),
	Zeitpunkt #=<Zeit.		
			% Hier wird geprft, ob das Modul b_PRG abgeschlossen ist.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 4.5.7

 voraussetzung_MOD_DS_GL(Zeit) :-
	pruefungsversuche_BM(W),
	member(pruefung_basis{modul_nr:b_MOD, pruefungszeit:Zeitpunkt1, note:X1},W), 	
	member(pruefung_basis{modul_nr:b_DS, pruefungszeit:Zeitpunkt2, note:X2},W),
	not(X1 = 5.0),
	not(X2 = 5.0),
	Zeitpunkt1 #=< Zeit,		
	Zeitpunkt2 #=< Zeit, !.	
			% Hier wird geprft, ob beide Module (b_MOD und b_DS)
			% bereits abgeschlossen sind.

 voraussetzung_MOD_DS_GL(Zeit) :-
	pruefungsversuche_BM(W),
	member(pruefung_basis{modul_nr:b_GL, pruefungszeit:Zeitpunkt, note:X},W),
	not(X = 5.0),
	Zeitpunkt #=<Zeit.		
			% Hier wird geprft, ob das Modul b_GL abgeschlossen ist.


 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  Prdikat 5.

das_Gebiet_Vertiefungsmodul_abgesch(Module, CP_Summe, Gebiete) :-

	suche_alle_bestandene_Module_Vertiefung(Module),
			% Hier werden alle erfolgreiche Prfungsversuche rausgefiltert.

	pruefe_ob_alle_Vertiefungsmodule_regelgemaess_abgesch(Module),
			% Hier wird geprft, ob der Student die Module regelgemss
			% abgeschlossen hat.
		
	die_CP_Summe_mindestens_40(Module, CP_Summe),
			% Hier wird geprft, ob Student mindestens 40 CP erzielt hat.

	seminar_und_Praktikum_enthalten(_Praktikum, _Seminar),
			% Hier wird geprft, ob Stundent ein Seminar und Praktikum 
			% erfolgreich abgeschlossen hat.

	drei_disjunkte_Gebiete(S1, S2, S3),
		
	Gebiete = [S1, S2, S3].  

%
%%%%%%%%%%%%%%%%   Ende der Prdikats    %%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	


           /* Im folgenden werden Klauseln definiert, die im  Prdikat 5. benutzt wurden.*/


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 5.1  

suche_alle_bestandene_Module_Vertiefung(List) :-
	pruefungsversuche_VM(W),
	(foreach(X1, W), 
	fromto(L, Out, In, []) do
		X1 = pruefung_vertiefung{note: 5.0} ->  Out = In 
		;
		Out = [X1|In]),
			
			% Hier werden alle erfolgreiche Prfungsversuche 
			% rausgefiltert und in die Liste L geschrieben.
	(foreach(X2, L),
	foreach(Y2, List) do
		finde_die_Modul_nr(X2, Y2)).
			% In der Liste List  werden die Modulnummer aller 
			% Prfungsversuche gesamelt.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 5.2
%
pruefe_ob_alle_Vertiefungsmodule_regelgemaess_abgesch(Module) :-
	(foreach(X, Module) do
		ein_Wahlpflichtmodul_abgesch_Vertiefung(X)).
			% Hier wird geprueft, ob der Student die Module 
			% regelgemss abgeschlossen hat.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 5.3  

die_CP_Summe_mindestens_40(Liste, C) :-
	
	(foreach(X, Liste),
	foreach(Y, T) do
		finde_CP_des_Moduls(X, Y)),
			% In der Liste T werden die erzielten CP gesamelt.
	sum(T, C),
	 C #>= 40.
			% Hier wird geprft, ob die Summe der erzielten CP 
			% mindestens 40 betrgt.




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 5.4  

seminar_und_Praktikum_enthalten(A, B) :-
	pruefungsversuche_VM(C),		
	member(pruefung_vertiefung{modul_nr:A, note: T1}, C),
	T1 \= 5.0,
	member(pruefung_vertiefung{modul_nr:B, note: T2}, C),
	T2 \= 5.0,
	alle_Vertiefungsmodule(G),
	member(v_modul{modul_nr:A, lehrform: prkt}, G),
	
	member(v_modul{modul_nr:B, lehrform: smn}, G).
	 
			% Hier wird geprft, ob der Student ein Seminar und ein 
			% Praktikum erfolgreich abgeschlossen hat.
	


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 5.5  

drei_disjunkte_Gebiete(D1, D2, D3) :-
	
	suche_alle_bestandene_Module_Vertiefung(List),
				% Siehe O oben.
	drei_Wahlgebiete_Vertiefung(V),
	member(wahlgebiet{gebiet_1:D1, gebiet_2:D2, gebiet_3:D3}, V),
				% Hier werden die drei Wunschgebiete des
				% Studenten gesucht.

	berechne_CP_Summe(List, D1, Summe_1),
				% Die Summe der  im Gebiet D1 ezielten erzielten
				%  CP  werden in die Liste Summe_1 geschrieben.

	berechne_CP_Summe(List, D2, Summe_2),
				% Die Summe der  im Gebiet D2 ezielten erzielten
				%  CP  werden in die Liste Summe_2 geschrieben.
	
	berechne_CP_Summe(List, D3, Summe_3),
				% Die Summe der  im Gebiet D3 ezielten erzielten
				%  CP  werden in die Liste Summe_3 geschrieben.
	Summen = [Summe_1, Summe_2, Summe_3], 
			% Hier werden die Summen der drei Gebiete 
			% in die Liste Summen geschrieben.  

	print(Summen), nl,
	filter(Summen, 16, Rest1),		 
	filter(Rest1, 8, Rest2),
	filter(Rest2, 8, _Rest3).
			
			% Hier wird die Klausel filter / 3 fr die drei disjunkte
			% Gebiete drei mal aufgerufen. Dabei sollen in den Gebieten
			% jeweils 16, 8 und 8  CP  erzielt werden.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 5.5.1

berechne_CP_Summe(L1, U, D) :-
	(foreach(X, L1), 
	fromto(L2, Out, In, []),
	param(U) do
		alle_Vertiefungsmodule(V),
		(member(v_modul{modul_nr:X, gebiet:U}, V) -> Out = [X|In]
		;
		Out = In)),
			% Prfungsleistungen im Gebiet U werden in die
			% Liste L2 geschrieben. 	
		
		(foreach(A, L2),
		foreach(B, L3) do
			finde_CP_des_Moduls(A, B)),
			sum(L3, D).
				% Die im Gebiet U erzielten CP  werden addiert 
				% und die Summe wird in die Liste D geschrieben.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 5.5.2

filter([], _, _) :-  false.	 	% Die leere Liste enthlt kein Modul 
filter([X|T], Z, R) :- 		
	(X #>= Z, 
	R = T)
	;			
	(X #< Z, 
	append([X], W1, R), 	
	filter(T, Z, W1)).	
			% Hier wird rekursiv definiert, wie aus einer Liste von 		
			% Zahlen die gesuchte Zahl rausgefiltert und wie der 
			% Rest fr den nchsten Aufruf vorbereitet wird.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  Prdikat 6.

finde_best_moegliche_durchschnittsnote_Vertiefung(Durchschnittsnote, Variationen) :-
	
	findall(Durchschnittsnote, berechne_Durchschnittsnote_Vertiefung(_, _, _, _, Durchschnittsnote) , N), 
			% Mit diesem Prdikat werden alle mgliche 
			% Durchschnittsnoten berechnet und in die Liste N geschrieben.
	X is min(N),
			% Der Variable X wird die kleinste Zahl zugeordnet.
			 
	breal_min(X, Durchschnittsnote), 
			% Hier wird aus dem Interval X die Untere Grenze
			% genommen und der Variable Durchschnitt zugeordnet.

	length(N, Variationen), 
	print(Variationen), nl.	
			% Hier wird zur Kontrolle die Zahl der mglichen 
			% Durchschnittsnoten berechnet und ausgegeben.


%
%%%%%%%%%%%%%%%%   Ende des Prdikats    %%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





		
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  Prdikat 7.

berechne_Durchschnittsnote_Vertiefung(CP_Gesamt, List_CP, CP_Vertiefung, 
		CP_Anteile, Durchschnittsnote) :-
	
	suche_alle_bestandene_Module_Vertiefung(List),
				% Hier werden alle erfolgreich abgeschlossene 
				% Module gesucht. 

	suche_alle_erzielte_CP(List, List_CP),
	sum(List_CP, CP_Vertiefung),
				% Hier werden die CP der Module gesucht.

	suche_alle_erzielte_Noten(List, List_Noten),
				% Hier werden die zugehrigen Noten geschrieben.
	
	ordne_CP_Anteile_zu(List_CP, CP_Anteile),
				% Hier wird jeder CP-Zahl in der Liste List_CP
				% ein CP-Anteil zugeordnet. 
	
	sum(CP_Anteile, CP_Gesamt),
	CP_Gesamt = 40,
				% Hier wird vorausgesetzt, dass die Summe der 
				% CP_Anteile genau 40 entspricht.

	gewichtung_der_Noten_durch_CP(List_Noten, CP_Anteile, Gewichtung),
				% Alle numerische Noten werden mit CP  gewichtet.

	sum(Gewichtung, Total),
				% Bildung der Summe aller Produkte( Total).
	
	bilde_CP_Summe_der_benoteten_Module(List_Noten, CP_Anteile, CP_Summe),
				% Bildung der CP-Summe ohne die CP der 
				% unbenoteten Module.

	/(Total, CP_Summe, Durchschnittsnote),
				% Bildung von Durchschnittsnote fr Basismodule
	
				
	die_CP_der_Wunschgebiete_erfuellt(Summe1, Summe2, Summe3, CP_Anteile),
				% Hier wird geprft, ob in den Wunschgebieten
				% 16, 8 bzw 8 CP erreicht wurde.

	zwischenergebnisse(List, List_Noten, List_CP, CP_Anteile, 
		Summe1, Summe2, Summe3, Durchschnittsnote).								% Hier werden Zwischenergebnisse zur Kontrolle 
				% ausgegeben.

%
%%%%%%%%%%%%%%%%   Ende des Prdikats    %%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

         
            /* Im folgenden werden Klauseln definiert, die im  Prdikat 7. benutzt wurden.*/

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 7.1  

suche_alle_erzielte_CP(List, List_CP) :-
	(foreach(X, List),
	foreach(Y, List_CP) do
		finde_CP_des_Moduls(X, Y)).

			% Hier werden die CP der Module gesucht.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 7.2  

suche_alle_erzielte_Noten(List, List_Noten) :-
	(foreach(X, List),
	foreach(Y, List_Noten) do
		suche_Pruefungsnote(X, Y)).

				% Hier werden alle Prfungsnoten gesucht.

%%%%%%%%% 7.2.1

suche_Pruefungsnote(X, Y) :-
	pruefungsversuche_VM(W),
	member(pruefung_vertiefung{modul_nr:X, note:Y}, W),
	not(Y =  5.0).

			% Hier wird fr ein Modul die zugehrige Note gesucht.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 7.3


ordne_CP_Anteile_zu(List_CP, CP_Anteile) :-
	(foreach(X1, List_CP), 
	foreach(Y1, CP_Anteile) do
		Y1 #:: [0 .. X1],
		indomain(Y1)).		
				% Das Prdikat indomain(Y1) ordnet Y1 einen 
				% Wert aus dem Wertebereich [0 .. X1] zu.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 7.4

gewichtung_der_Noten_durch_CP(List_Noten, CP_Anteile, Gewichtung) :-
	(foreach(X2, List_Noten), 
	foreach(Y2, CP_Anteile),
	foreach(Z, Gewichtung) do
		real(X2) -> *(X2, Y2, Z) 
		; 
		Z =0).
				% Alle numerische Noten werden mit CP  gewichtet.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 7.5

bilde_CP_Summe_der_benoteten_Module(List_Noten, CP_Anteile, Summe) :-
	(foreach(X, List_Noten), 
	foreach(Y, CP_Anteile),
	foreach(Z, T4) do
		real(X) -> Z = Y  
		; 
		Z =0),
	sum(T4, Summe).	
				% Die CP der nicht numerischen und fr den 
				% Durchschnitt uninteressanten Noten bekommen
				% den Wert  0. Die CP der restlichen wird addiert.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% 7.6

die_CP_der_Wunschgebiete_erfuellt(Summe1, Summe2, Summe3, CP_Anteile) :-

	
	suche_die_drei_Wunschgebiete(D1, D2, D3),
					% Hier werden die Drei Wuschgebiete 
					% des Studenten den Variablen D1, D2
					% und D3 zugeordnet.	
	suche_alle_bestandene_Module_Vertiefung(List),
				% Hier werden alle erfolgreich abgeschlossene 
				% Module gesucht. 		
	(foreach(X, List),
	foreach(Y, Gebiete) do
		finde_Gebiet_des_Moduls(X, Y)), 
					% Hier wird  das Gebiet eines jeden
					% bestandenen Modul gesucht und in
					% die Liste Gebiete geschrieben.

	summiere_CP_im_Gebiet(Gebiete, CP_Anteile, D1, T1),
	summiere_CP_im_Gebiet(Gebiete, CP_Anteile, D2, T2),
	summiere_CP_im_Gebiet(Gebiete, CP_Anteile, D3, T3),
					% Hier wird aus der Liste Gebiete alle 
					% CP-Anteile den Gebieten D1, D2 und 
					% D3 in die Liste CP_in_D geschrieben.
	sum(T1, Summe1),
	sum(T2, Summe2),
	sum(T3, Summe3),
					% Hier werden CP_Summe der einzelnen
					% Gebiete berechnet.		
	Summen = [Summe1, Summe2, Summe3],

	filter(Summen, 16, Rest1),		 
	filter(Rest1, 8, Rest2),
	filter(Rest2, 8, _Rest3).

			% Hier wird die Klausel  filter / 3 fr die drei disjunkte
			% Gebiete drei mal aufgerufen. Dabei sollen in den Gebieten
			% jeweils 16, 8 und 8  CP  erzielt werden.


%%%%%%%%% 7.6.1

suche_die_drei_Wunschgebiete(D1, D2, D3) :-
	drei_Wahlgebiete_Vertiefung(V),
	member(wahlgebiet{gebiet_1:D1, gebiet_2:D2, gebiet_3:D3}, V).
				% Hier werden die drei Wunschgebiete des
				% Studenten gesucht der Variablen D1, D2 und D3
				% zugeordnet.


%%%%%%%%%%7.6.2

finde_Gebiet_des_Moduls(X, Y) :-
	alle_Vertiefungsmodule(W),
	member(v_modul{modul_nr:X, gebiet: Y}, W).	
				% Hier wird der Variabe Y das Gebiet des  
				% bestandenen Modul X zugeordnet.


%%%%%%%%%% 7.6.3	

summiere_CP_im_Gebiet(Gebiete, CP_Anteile, D, CP_in_D) :-
	(foreach(X, CP_Anteile),
	foreach(Y, Gebiete),
	foreach(Z, CP_in_D),
	param(D) do
		(Y = D  ->  Z = X
		;
		Z = 0)).		
				% Hier werden alle CP-Anteile eines Gebiets D in 
				% die Liste CP_in_D geschrieben.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% 7.7

zwischenergebnisse(List, List_Noten, List_CP, CP_Anteile, 
		Summe1, Summe2, Summe3, Durchschnittsnote) :-

        	print('Alle Module: '), 
	print(List),nl,
	print('Alle Noten: '),
       	print(List_Noten),nl,
	print('Alle CP: '), 
	print(List_CP),nl,	
      	print('Alle CP-Anteile: '), 
       	print(CP_Anteile), nl,
	print(Summe1), nl,
	print(Summe2), nl,
	print(Summe3), nl,
	print('Durchschnittsnote : '), 
	print(Durchschnittsnote), nl.
				% Hier werden Zwischenergebnisse zur 
				% zur Kontrolle ausgegeben.


